const int  voicetype = 0;  // пищалка -  0 - 61003, 1 - Miroschnik


/*
ROTARY SWITCH (ручка управления вид сверху)
 
 b1      +5
 |       |
 
 
 |   |   |
 b3  +5   b2
 
 Жестко заданы пины для аппаратного SPI:
 11 - IN  дисплея
 13 - CLK дисплея
 */

const int  Pin_cs = 10;       //CS MAX7219
const int  Pin_b1 = 6;        //ROTARY 1
const int  Pin_b2 = 7;        //ROTARY 2
const int  Pin_b3 = 8;        //ROTARY 3
const int  Pin_voice = 0;     //ЗВУК
const int  Pin_relay = 2;     //РЕЛЕ

const int  Pin_mot1_1= 15;    //ДВИГАТЕЛЬ 2 ОБМОТКА 1
const int  Pin_mot1_2= 14;    //ДВИГАТЕЛЬ 2 ОБМОТКА 2
const int  Pin_mot1_3= 9;    //ДВИГАТЕЛЬ 2 ОБМОТКА 3
const int  Pin_mot1_4= 4;     //ДВИГАТЕЛЬ 2 ОБМОТКА 4

const int  Pin_mot2_1= 19;    //ДВИГАТЕЛЬ 1 ОБМОТКА 1
const int  Pin_mot2_2= 18;    //ДВИГАТЕЛЬ 1 ОБМОТКА 2
const int  Pin_mot2_3= 17;    //ДВИГАТЕЛЬ 1 ОБМОТКА 3
const int  Pin_mot2_4= 16;    //ДВИГАТЕЛЬ 1 ОБМОТКА 4

#define W1_PORT PORTD
#define W1_DDR DDRD
#define W1_PIN PIND
#define W1_BIT 5              //Датчик температуры куба пин №5

#define W2_PORT PORTB
#define W2_DDR DDRB
#define W2_PIN PINB
#define W2_BIT 4              //Датчик температуры колонны пин №12


#include <EEPROM.h>
#include <Stepper.h>
#include <LedControl.h>

// * Pin 11 is connected to the DATA IN-pin of the first MAX7221
// * Pin 13 is connected to the CLK-pin of the first MAX7221
// * Pin 10 is connected to the LOAD(/CS)-pin of the first MAX7221 	

LedControl lc=LedControl(11,13,10,1);
#define MOTOR_REV 32 * 64

#define STEPS_PER_MOTOR_REVOLUTION 32   
#define MOTOR_REV 32 * 64

Stepper motor1(STEPS_PER_MOTOR_REVOLUTION, Pin_mot2_1, Pin_mot2_3, Pin_mot2_2, Pin_mot2_4);
Stepper motor2(STEPS_PER_MOTOR_REVOLUTION, Pin_mot1_1, Pin_mot1_3, Pin_mot1_2, Pin_mot1_4);

const int  set_up_max=14;

const static char charSetup[set_up_max][3] = {
  {
    24,24,24          }
  ,   //  ...   - выход в основное меню 
  {
    10,5,10          }
  ,    //  tst 0 - температура отсчета работы на себя в колонне
  {
    10,11,12          }
  ,   //  tdn 1 - температура, с которой начинается уменьшение отбора (десятая градуса)
  {
    10,11,13          }
  ,   //  tdl 2 - температура до который снижается отбор (десятая градуса) 
  {
    10,14,22          }
  ,   //  teb 3 - температура, до которой отбираем тело (десятые градуса)
  {
    10,14,12          }
  ,   //  ten 4 - температура окончания процесса (десятые градуса) (сработка реле окончания процесса)
  {
    10,5,15          }
  ,    //  tsf 5 - время работы на себя (мин)
  {
    10,16,11          }
  ,   //  tid 6 - время нахождения иглы внизу отбора для заполнения шланга перед началом отбора голов (десятые минут)
  {
    23,14,11          }
  ,   //  hed 7 - время отбора голов (мин)
  {
    5,21,13          }
  ,   //  scl 8 - шаг калибровки
  {
    19,20,10          }
      //  aut 9 - автоподмотка

  ,  //  ttl 10 - время ожидания хвостов в минутах
  {
    10,10,13          }

  ,  //  222 11 - наличие второго мотора
  {
    2,2,2          }
  ,  //  au5 12 - автозапуск do1
  {
    19,20,5          }

};


const static char charRej[5][3] = {
  {
    5,14,10          }
  ,    //  set 1 - настройки
  {
    21,13,1          }
  ,   //  cl1 2 - калибровка иглы
  {
    21,13,2          }
  ,   //  cl2 3 - калибровка разливайки
  {
    11,18,1          } //do1 - старт по полной схеме
  ,
  {
    11,18,2          } //do2 - старт по полной схеме
  
};

const static char charVar[10][3] = {
  {
    23,14,11          }
  ,    //  hed
  {
    22,18,11          }
  ,   //  bod
  {
    15,5,25          }
  ,   //  FS  
  {
    5,10,22          }
  ,    //  Stb
  {
    22,20,10    }
  ,      //but
  {
    10,18,12    }
  ,      //ton
  {
    10,19,13    }
  ,       //tal
  {
    14,12,11    }//end
  ,      
  {
    12,20,13    }//nuL
  ,      
  {
    10,10,10    }//st.

};





const static long par_min[set_up_max-1]=   {
  1,  200,   200, 200, 200, 0  ,0,  0,   0,0,0,0,20};
const static long par_max[set_up_max-1]=   {
  999,  999,  999, 999, 999, 999 ,999, 999, 999,1,999,1,999};
const static char par_point[set_up_max-1]={0,   1,    1, 1,   1,   0,  1,  0,   0,0,0,0,0};

char rej=0,set_up=0,rej_max=4,lev=0,rej_step=0,tic=0,tmpb=0,podm=0;
int i=0,isbutton=0,Eaddress,temp_temp,is_start=0,curr_temp=0,tow_temp=0,rev_count=0,fact_rev_count=0,rev2_count=0,fact2_rev_count=0,is_down=0,rev_total=0,rev_temp=0,rev_count_temp=0,
rev_curr=0,tmp02=0,head_count=0,body_count=0,tic_voice=0,tic_sil=0,tic_kub=0,tic_kol=0,tic_tow=0,tow_temp_stop=0,fstop=0,tic_tw=0,stab_temp=0,flstop=0,stopcurr=0,
head_r_count=0,body_r_count=0,tal_r_count=0,nullfind=0;
int buttonState,NewState,OldState,upState,downState;
long par[set_up_max-1];
long stab_time=0,kol_head=0,down_count=0,null_count=0,kstep=0,currstep=0,delstep=0,tic_tal=0,tic_start=0;

void show_dis(int d1, int d2, int d3, int nn,int ff) {
  if (nn==2)
  {
    lc.setChar(0,3,d1,false);
    lc.setChar(0,1,d3,false);  

    if (((par_point[set_up-1]==1&rej==0&lev>0))|(fstop>0&(rej_step==4|rej_step==6))|(rej>2&rej_step==0&is_start>0))
    {
    lc.setChar(0,2,d2,true);
    }
else
{
    lc.setChar(0,2,d2,false);
    }

  }
  else
  {
    lc.setChar(0,7,d1,false);

    if (ff==1&rej>2&rej_step==4)
    {
    lc.setChar(0,5,d3,true);  
    }
    else
    {
    lc.setChar(0,5,d3,false);
    }


    if (rej>2&rej_step==4)
    {
    lc.setChar(0,6,d2,true);
    }
    else
    {
    lc.setChar(0,6,d2,false);
    }
    
  } 

lc.setChar(0,0,25,false);
lc.setChar(0,4,25,false);

}


unsigned char w1_find() {
  unsigned char device;
  W1_DDR |= 1 << W1_BIT;
  delayMicroseconds(485);
  W1_DDR &= ~(1 << W1_BIT);
  delayMicroseconds(65);
  if ((W1_PIN & (1 << W1_BIT)) == 0x00)
    device = 1;
  else
    device = 0;
  delayMicroseconds(420);
  return device;
}
unsigned char w2_find() {
  unsigned char device;
  W2_DDR |= 1 << W2_BIT;
  delayMicroseconds(485);
  W2_DDR &= ~(1 << W2_BIT);
  delayMicroseconds(65);
  if ((W2_PIN & (1 << W2_BIT)) == 0x00)
    device = 1;
  else
    device = 0;
  delayMicroseconds(420);
  return device;
}

void w1_sendcmd(unsigned char cmd) {
  for (unsigned char i = 0; i < 8; i++) {
    if ((cmd & (1 << i)) == 1 << i) {
      W1_DDR |= 1 << W1_BIT;
      delayMicroseconds(2);
      W1_DDR &= ~(1 << W1_BIT);
      delayMicroseconds(65);
    } 
    else {
      W1_DDR |= 1 << W1_BIT;
      delayMicroseconds(65);
      W1_DDR &= ~(1 << W1_BIT);
      delayMicroseconds(5);
    }
  }
}
void w2_sendcmd(unsigned char cmd) {
  for (unsigned char i = 0; i < 8; i++) {
    if ((cmd & (1 << i)) == 1 << i) {
      W2_DDR |= 1 << W2_BIT;
      delayMicroseconds(2);
      W2_DDR &= ~(1 << W2_BIT);
      delayMicroseconds(65);
    } 
    else {
      W2_DDR |= 1 << W2_BIT;
      delayMicroseconds(65);
      W2_DDR &= ~(1 << W2_BIT);
      delayMicroseconds(5);
    }
  }
}

unsigned char w1_receive_byte() {
  unsigned char data = 0;
  for (unsigned char i = 0; i < 8; i++) {
    W1_DDR |= 1 << W1_BIT;
    delayMicroseconds(2);
    W1_DDR &= ~(1 << W1_BIT);
    delayMicroseconds(7);
    if ((W1_PIN & (1 << W1_BIT)) == 0x00)
      data &= ~(1 << i);
    else
      data |= 1 << i;
    delayMicroseconds(50);
  }
  return data;
}
unsigned char w2_receive_byte() {
  unsigned char data = 0;
  for (unsigned char i = 0; i < 8; i++) {
    W2_DDR |= 1 << W2_BIT;
    delayMicroseconds(2);
    W2_DDR &= ~(1 << W2_BIT);
    delayMicroseconds(7);
    if ((W2_PIN & (1 << W2_BIT)) == 0x00)
      data &= ~(1 << i);
    else
      data |= 1 << i;
    delayMicroseconds(50);
  }
  return data;
}

int temp_18b20(unsigned char twl) {
  unsigned char data1[2],data2[2];
  int temp1 = 0,temp2 = 0,temp = 0;
  if (w1_find() == 1&w2_find() == 1) 
  {
    cli();
    w1_sendcmd(0xcc);
    w1_sendcmd(0x44);
    w2_sendcmd(0xcc);
    w2_sendcmd(0x44);
    sei();
    delay(1000);
    cli();
    w1_find();
    w2_find();
    w1_sendcmd(0xcc);
    w1_sendcmd(0xbe);
    w2_sendcmd(0xcc);
    w2_sendcmd(0xbe);
    
    data1[0] = w1_receive_byte();
    data1[1] = w1_receive_byte();
    data2[0] = w2_receive_byte();
    data2[1] = w2_receive_byte();
sei();
    temp1 = data1[1];
    temp1 = temp1 << 8;
    temp1 |= data1[0];
    curr_temp = temp1 * 0.625;

if (twl>0)
{
    temp2 = data2[1];
    temp2 = temp2 << 8;
    temp2 |= data2[0];
    temp2= temp2 * 0.625;
    tow_temp = temp2 ; 
}

  }
  return temp;
}


int get_100(int data) {
  return data / 100;
}

int get_10(int data) {
  return (data - data / 100 * 100) / 10;
}

int get_1(int data) {
  return (data - data / 100 * 100) % 10;
}


void Eread()
{
  for (int j=1;j<set_up_max;j++)
  {
    long tmp1;
    tmp1 = EEPROM.read(j*2-1)*100+EEPROM.read(j*2);
    par[j-1] = tmp1;

    if (tmp1==0)
    {
      par[j-1] = par_min[j-1];
    }
    else
    {
      par[j-1] = tmp1;
    }

  }
}

void Ewrite()
{
  EEPROM.write(set_up*2-1, par[set_up-1]/100);
  EEPROM.write(set_up*2,  par[set_up-1]-par[set_up-1]/100*100);
}



ISR(TIMER2_COMPA_vect) 
{
  buttonState = digitalRead(Pin_b3)*2+digitalRead(Pin_b2)*4;

  
  if (digitalRead(Pin_b1)==0&nullfind==0&rej==0&podm==1)
  {
             if (rev_count==fact_rev_count)
             {
            fact_rev_count=0;
            rev_count=0;
            nullfind=1;  
            podm=0;
            tic_start=par[12]*10;
//            tic_start=600;
             }
  }
  
  if (digitalRead(Pin_b1)==1&isbutton==0)
  {
    if (is_start==0)
    {

      switch (lev)
      {
      case 0:
        {
          if (rej==0&nullfind==1)
          {
            lev=1;
          }
          if (rej==0&nullfind==0)
          {
              if (tic_sil==0&nullfind==0&par[9]>0)
             {
               rev_count=rev_count+5;
               podm=1;
             }

          }
 
          if (rej>0)
          {
            is_start=1;
            null_count=EEPROM.read(50)*100+EEPROM.read(51);
            head_count=EEPROM.read(52)*100+EEPROM.read(53);
            body_count=EEPROM.read(54)*100+EEPROM.read(55);          
            head_r_count=EEPROM.read(56)*100+EEPROM.read(57);
            body_r_count=EEPROM.read(58)*100+EEPROM.read(59);
            tal_r_count=EEPROM.read(60)*100+EEPROM.read(61);          
            

            stab_time=par[5]*600;
            kol_head=par[7]*600;

            if (rej==4)
            {
              tic_tw=45;
              rej_step=3;
            }

          }

          break;    
        }
      case 1:
        {
          if (set_up==0)
          {
            lev=0;
          }
          else
          {
            lev=2;
          }
          break;    
        }
      case 2:
        {
          Ewrite();
          lev=1;
          break;    
        }

      } 
    }    
    else
    {
      switch (rej)
      {
      case 1:
        {
          switch (rej_step)
          {
          case 0:

            {
              EEPROM.write(50, rev_count/100);
              EEPROM.write(51,  rev_count-rev_count/100*100);   
              rej_step=1;
              break;
            }

          case 1:

            {
              EEPROM.write(52, rev_count/100);
              EEPROM.write(53,  rev_count-rev_count/100*100);   
              rej_step=2;
              break;
            }

          case 2:
            {

              EEPROM.write(54, rev_count/100);
              EEPROM.write(55,  rev_count-rev_count/100*100);   
              rej_step=0;
              rev_count=0;
              is_start=0;
              set_up=0;
              lev=0;
              rej=0;
              break;
            }

          }
          break;
        }
        case 2:
        {
          switch (rej_step)
          {
          case 0:

            {
              EEPROM.write(56, rev2_count/100);
              EEPROM.write(57,  rev2_count-rev2_count/100*100);   
              rej_step=1;
              break;
            }

          case 1:

            {
              EEPROM.write(58, rev2_count/100);
              EEPROM.write(59,  rev2_count-rev2_count/100*100);   
              rej_step=2;
              break;
            }

          case 2:
            {

              EEPROM.write(60, rev2_count/100);
              EEPROM.write(61,  rev2_count-rev2_count/100*100);   
              rej_step=0;
              rev2_count=0;
              is_start=0;
              set_up=0;
              lev=0;
              rej=0;
              break;
            }

          }
          break;
        }

        
      case 3:
        {
          switch (rej_step)
          {
            
          case 3:
///////////////////////////////////////////////////////если сменили тару, продолжаем отбирать тело
            {
              stab_temp=tow_temp;
              rej_step=4;
              fact_rev_count=0;                  
              rev_count = body_count;
              rev_curr=rev_curr+rev_count;
              rev_total = rev_count;
              rev_temp = (par[3]-par[1]*10+1)/par[2];
              rev_count_temp = rev_count/rev_temp;
              tic_kub=30;

              fact2_rev_count=0;                  
              rev2_count = body_r_count-head_r_count;

              break;
            }

          case 5:
            {
    fact2_rev_count=0;                  
    rev2_count = tal_r_count-body_r_count;

              fact_rev_count=0;
              rev_count=body_count;
              rev_curr=rev_curr+rev_count;
              rej_step=6;
              break;
            }
          case 7:
            {
              rev_curr=0;
              rej_step=0;
              rev_count=0;
              is_start=0;
              set_up=0;
              lev=0;
              rej=0;
              break;
            }

          }
          break;
        }

      case 4:
        {
          switch (rej_step)
          {
            
          case 3:
///////////////////////////////////////////////////////если сменили тару, продолжаем отбирать тело
            {
              stab_temp=tow_temp;
              rej_step=4;
              fact_rev_count=0;                  
              rev_count = body_count;
              rev_curr=rev_curr+rev_count;
              rev_total = rev_count;
              rev_temp = (par[3]-par[1]*10+1)/par[2];
              rev_count_temp = rev_count/rev_temp;
              tic_kub=30;
              stopcurr=rev_count;

              fact2_rev_count=0;                  
              rev2_count = body_r_count-head_r_count;

              break;
            }

          case 5:
            {
    fact2_rev_count=0;                  
    rev2_count = tal_r_count-body_r_count;

              fact_rev_count=0;
              rev_count=body_count;
              rev_curr=rev_curr+rev_count;
              rej_step=6;
              break;
            }
          case 7:
            {
              rev_curr=0;
              rej_step=0;
              rev_count=0;
              is_start=0;
              set_up=0;
              lev=0;
              rej=0;
              break;
            }

          }
          break;
        }

      }
    }
    isbutton=1000;
   // lc.clearDisplay(0);
}

  isbutton--;
  if (isbutton<1)
  {
    isbutton=0;
  }


  NewState=buttonState;
  if(NewState!=OldState)
  {
    switch(OldState)
    {
    case 4:
      {
        if(NewState == 6) upState++;
        if(NewState == 0) downState++; 
        break;
      }

    case 0:
      {
        if(NewState == 4) upState++;
        if(NewState == 2) downState++; 
        break;
      }
    case 2:
      {
        if(NewState == 0) upState++;
        if(NewState == 6) downState++; 
        break;
      }
    case 6:
      {
        if(NewState == 2) upState++;
        if(NewState == 4) downState++; 
        break;
      }
    }            
    OldState=NewState;
  }

  if (upState >= 4)
  {

    if (is_start>0&rej==1)
    {
      rev_count++;
    }

    if (is_start>0&rej==2)
    {
      rev2_count++;
    }


    if (is_start==0)
    {
      switch (lev)
      {
      case 0:
        {
          rej++;  
          if (rej>rej_max)
          {
            rej=0;
          }
          break;
        }
      case 1:
        {
          set_up++;  
          if (set_up>set_up_max-1)
          {
            set_up=0;
          }
          break;
        }
      case 2:
        {
          par[set_up-1]++;  
          if (par[set_up-1]>par_max[set_up-1])
          {
            par[set_up-1]=par_min[set_up-1];
          }
          break;
        }
      }
    }
    upState=0;
   // lc.clearDisplay(0);
  }

  if (downState >= 4)
  {
    if (is_start>0&rej==1)
    {
      if (rev_count>0)
      {
        rev_count--;
      }
    }
    if (is_start>0&rej==2)
    {
      if (rev2_count>0)
      {
        rev2_count--;
      }
    }


    if (is_start==0)
    {


      switch (lev)
      {
      case 0:
        {
          if (rej==0)
          {
            rej=rej_max+1;
          }
          rej--;  

          break;    
        }
      case 1:
        {
          if (set_up==0)
          {
            set_up=set_up_max;
          }
          set_up--;  

          break;    
        }
      case 2:
        {
          if (par[set_up-1]==par_min[set_up-1])
          {
            par[set_up-1]=par_max[set_up-1]+1;
          }
          par[set_up-1]--;  
          break;    
        }
      }
    }
    downState=0;
   // lc.clearDisplay(0);
  }


}

//00000000000000000000000000000000000000000000000000000000000000000000000000000000000011111111111111111111111111111111111111111111111111111111111111
ISR(TIMER1_COMPA_vect) 
{
  if (tic_start>0&lev==0)
  {
    tic_start--;
  }


  if (rej>2&is_start>0&rej_step==4)
  {

  if (tic_kub>0)
  {
    tic_kub--;
  }
  if (tic_kol>0)
  {
    tic_kol--;
  }
  if (tic_tow>0)
  {
    tic_tow--;
  }
  if (tic_tal>0)
  {
    tic_tal--;
  }


  }
  
  if (tic_voice>0)
  {
    tic_voice--;
  }
  if (tic_sil>0)
  {
    tic_sil--;
  }

//////////////////////////////////////////////////////////////////////////Если время работы на себя вышло, переходим в режим опукания иглы
  if (rej==3&is_start>0&rej_step==1)
  {
    if (stab_time>0)
    {
      stab_time--;
    }
    else
    {
      rej_step=2;
    }
  }
//////////////////////////////////////////////////////////////////////////Если игла спущена, то начинаем отсчет времени заполнения иглы  
  if (rej==3&is_start>0&rej_step==2&is_down==2)
  {
    if (down_count>0)
    {
      down_count--;
    }
    else
    {
      is_down=3;
    }


  }
  
  ////////////////////////////////////////////////////////////Если начали собирать головы, то запускаем таймер отсчета. 
  ////////////////////////////////////////////////////////////Если таймер истек, то поднимаем иглу на ноль и ждем смены тары.
  if (rej==3&is_start>0&rej_step==2&is_down==4)
  {
    if (kol_head>0)
    {
      kol_head--;
    }
    else
    {

if (par[11]==0)
{
      rej_step=3;
            fact_rev_count=0;    
      rev_count = -head_count;
      rev_curr=rev_curr+rev_count;      

}
else
{
  tic_voice=10;
  rej_step=4;
          

         stab_temp=tow_temp;

              fact_rev_count=0;                  
              rev_count = body_count-head_count;
              rev_curr=rev_curr+rev_count;
              rev_total = rev_count;
              rev_temp = (par[3]-par[1]*10+1)/par[2];
              rev_count_temp = rev_count/rev_temp;
              tic_kub=30;
              fact2_rev_count=0;                  
              rev2_count = body_r_count-head_r_count;
}

    }
  }

}


void set_display()
{
  if (is_start==0)
  {
    if (lev==0)
    {
      show_dis(charRej[rej][0],charRej[rej][1],charRej[rej][2],1,0);

      show_dis(25,25,25,2,0);
    }
    else
    {
      show_dis(charSetup[set_up][0],charSetup[set_up][1],charSetup[set_up][2],1,0);

      if (set_up==0)
      {
        show_dis(25,25,25,2,0);
      }
      else
      {
        show_dis(get_100(par[set_up-1]),get_10(par[set_up-1]),get_1(par[set_up-1]),2,0);
      }
    }
  }
  else
  {
    if (rej==1)
    {
      if (rej_step==0)
      {
        show_dis(charVar[8][0],charVar[8][1],charVar[8][2],1,0);
      }
      if (rej_step==1)
      {
        show_dis(charVar[0][0],charVar[0][1],charVar[0][2],1,0);
      }
      if (rej_step==2)
      {
        show_dis(charVar[1][0],charVar[1][1],charVar[1][2],1,0);
      }

      show_dis(get_100(rev_count),get_10(rev_count),get_1(rev_count),2,0);
    }  
    if (rej==2)
    {
      if (rej_step==0)
      {
        show_dis(charVar[0][0],charVar[0][1],charVar[0][2],1,0);
      }
      if (rej_step==1)
      {
        show_dis(charVar[1][0],charVar[1][1],charVar[1][2],1,0);
      }
      if (rej_step==2)
      {
        show_dis(charVar[6][0],charVar[6][1],charVar[6][2],1,0);
      }

      show_dis(get_100(rev2_count),get_10(rev2_count),get_1(rev2_count),2,0);
    }  

    if (rej>2)
    {
      if (rej_step==0)
      {
        show_dis(charVar[2][0],charVar[2][1],charVar[2][2],1,0);
        show_dis(get_100(tow_temp),get_10(tow_temp),get_1(tow_temp),2,0);
      } 
      if (rej_step==1)
      {
        show_dis(charVar[3][0],charVar[3][1],charVar[3][2],1,0);
        show_dis(get_100(stab_time/600),get_10(stab_time/600),get_1(stab_time/600),2,0);
      } 
      if (rej_step==2)
      {
        show_dis(charVar[0][0],charVar[0][1],charVar[0][2],1,0);
        show_dis(get_100(kol_head/600),get_10(kol_head/600),get_1(kol_head/600),2,0);
      } 
      if (rej_step==3|rej_step==5)
      {
        show_dis(charVar[4][0],charVar[4][1],charVar[4][2],1,0);
        show_dis(charVar[5][0],charVar[5][1],charVar[5][2],2,0);        
      } 
      if (rej_step==4)
      {
        if (tic_kub>0&tic_kol==0)
        {
          show_dis(get_100(curr_temp),get_10(curr_temp),get_1(curr_temp),1,0);
          tmpb=1;
        }
        if (tic_kol>0&tic_kub==0)
        {
          show_dis(get_100(tow_temp),get_10(tow_temp),get_1(tow_temp),1,1);
          tmpb=2;
        }

        if (tic_kol==0&tic_kub==0)
        {
          if (tmpb==1)
          {
            tic_kol=30;
          }
          if (tmpb==2)
          {
            tic_kub=30;
          }

        }
        
        
        if (fstop==0)
        {
        show_dis(get_100(rev_curr),get_10(rev_curr),get_1(rev_curr),2,0);
        }
        if (fstop==1&tow_temp>=stab_temp)
        {
        show_dis(charVar[9][0],get_10(tow_temp-stab_temp),get_1(tow_temp-stab_temp),2,1);          
        }
        if (fstop==1&tow_temp<stab_temp)
        {
        show_dis(charVar[9][0],get_10(0),get_1(0),2,1);          
        }


      } 
      if (rej_step==6)
      {
        show_dis(charVar[6][0],charVar[6][1],charVar[6][2],1,0);
        show_dis(get_100(curr_temp),get_10(curr_temp),get_1(curr_temp),2,0);
      } 
      if (rej_step==7)
      {
        show_dis(charVar[7][0],charVar[7][1],charVar[7][2],1,0);
        show_dis(25,25,25,2,0);
      } 

    }  

  }
}

void setup()
{

//  Serial.begin(9600);

  pinMode(Pin_cs, OUTPUT);
  pinMode(Pin_b1, INPUT); 
  pinMode(Pin_b2, INPUT); 
  pinMode(Pin_b3, INPUT); 
  pinMode(Pin_voice, OUTPUT); 
  pinMode(Pin_relay, OUTPUT); 
  pinMode(Pin_mot1_1, OUTPUT); 
  pinMode(Pin_mot1_2, OUTPUT); 
  pinMode(Pin_mot1_3, OUTPUT); 
  pinMode(Pin_mot1_4, OUTPUT); 
  pinMode(Pin_mot2_1, OUTPUT); 
  pinMode(Pin_mot2_2, OUTPUT); 
  pinMode(Pin_mot2_3, OUTPUT); 
  pinMode(Pin_mot2_4, OUTPUT); 

  motor1.setSpeed(900);
  motor2.setSpeed(900);


   //wake up the MAX72XX from power-saving mode 
   lc.shutdown(0,false);
   //set a medium brightness for the Leds
   lc.setIntensity(0,8);
   
  cli();
  TCCR1A = 0;
  TCCR1B = 0;
  TCNT1 = 0;
  OCR1A = 1562;// = (1/10) / ((1/(16*10^6))*1024) 
  TCCR1B |= (1 << WGM12);
  TCCR1B |= (1 << CS10)|(1 << CS12);
  TIMSK1 |= (1 << OCIE1A);	

  TCCR2B = 0;
  TCNT2 = 0;
  OCR2A = 15;// = (1/1000) / ((1/(16*10^6))*1024) 
  TCCR2B |= (1 << CS10)|(1 << CS12);
  TIMSK2 |= (1 << OCIE2A);	
  sei();
  rej=0;
  Eread();
  
  tic_voice=20;
  tic_sil=100;
  if (par[9]==0)
  {
    nullfind=1;
  }

}


void loop()
{ 
/*
  Serial.print("curr ");
  Serial.print(curr_temp);
  Serial.print(" ");
  Serial.print("tow ");
  Serial.print(tow_temp);
  Serial.print(" ");
  Serial.print("tw_stop ");
  Serial.print(tow_temp_stop);
  Serial.print(" ");
  Serial.print("tic ");
  Serial.print(tic_tw);
  Serial.print(" ");
  Serial.print("fstop ");
  Serial.print(fstop);
  Serial.print(" ");
  Serial.print("flstop ");
  Serial.print(flstop);
  Serial.print(" ");
  Serial.print("stab ");
  Serial.print(stab_temp);
  Serial.print(" ");
  Serial.print("fakt ");
  Serial.print(fact_rev_count);
  Serial.print(" ");
  Serial.print("count ");
  Serial.print(rev_count);
  Serial.print(" ");
  Serial.print("curr ");
  Serial.print(rev_curr);
  Serial.print(" ");
  Serial.print("stopcurr");
  Serial.print(stopcurr);
  Serial.print(" ");
  Serial.print("tic_start ");
  Serial.print(tic_start);
  Serial.print(" ");
  Serial.print("tic_tal ");
  Serial.print(tic_tal);

  Serial.println(" ");
*/

if (is_start==0&nullfind==1&tic_start==0&par[12]>0&par[9]>0&lev==0)
          {
            is_start=1;
            null_count=EEPROM.read(50)*100+EEPROM.read(51);
            head_count=EEPROM.read(52)*100+EEPROM.read(53);
            body_count=EEPROM.read(54)*100+EEPROM.read(55);          
            head_r_count=EEPROM.read(56)*100+EEPROM.read(57);
            body_r_count=EEPROM.read(58)*100+EEPROM.read(59);
            tal_r_count=EEPROM.read(60)*100+EEPROM.read(61);          
            stab_time=par[5]*600;
            kol_head=par[7]*600;
            rej=3;

          }



  if(tic_voice>0)
  {
    if (voicetype==1)
    {
      digitalWrite(Pin_voice,LOW);
    }
    else
    {
      digitalWrite(Pin_voice,HIGH);
    }
  }
  else
  {
    if (voicetype==1)
    {
      digitalWrite(Pin_voice,HIGH);
    }
    else
    {
      digitalWrite(Pin_voice,LOW);
    }
  }

///////////////////////////////////////////////////////////Сбор температуры раз в минуту
  if (tic>15)
  {
    tic=0;
    if (is_start>0&rej>2&rev_count==fact_rev_count)
    {
      temp_temp=temp_18b20(0);    
    }
  }
  else
  {
    tic++;    
  }
  if (tic_tw>5*10)
  {
    tic_tw=0;
    if (is_start>0&rej>2&rev_count==fact_rev_count)
    {
      temp_temp=temp_18b20(1);    
    }
  }
  else
  {
    tic_tw++;    
  }

//////////////////////////////////////////////////////////через минуту после старта подматываем до нуля

  if (tic_sil==0&nullfind==0&par[9]>0&podm==0)
  {
    rev_count--;
  }

  if (rev_count>fact_rev_count&rev2_count==fact2_rev_count)
  {
    motor1.step(par[8]); 
    fact_rev_count++;
  }

  if (rev_count<fact_rev_count&rev2_count==fact2_rev_count)
  {
    motor1.step(-par[8]); 
    fact_rev_count--;
  }

  if (rev_count==fact_rev_count)
  {

    digitalWrite(Pin_mot2_1,LOW);
    digitalWrite(Pin_mot2_2,LOW);
    digitalWrite(Pin_mot2_3,LOW);
    digitalWrite(Pin_mot2_4,LOW);
  
}

  if (rev2_count>fact2_rev_count)
  {
    motor2.step(par[8]); 
    fact2_rev_count++;
  }

  if (rev2_count<fact2_rev_count)
  {
    motor2.step(-par[8]); 
    fact2_rev_count--;
  }

  if (rev2_count==fact2_rev_count)
  {

    digitalWrite(Pin_mot1_1,LOW);
    digitalWrite(Pin_mot1_2,LOW);
    digitalWrite(Pin_mot1_3,LOW);
    digitalWrite(Pin_mot1_4,LOW);
  
}


  ///////////////////////////////////////////////////////алгоритм 1 - ректификация по Ткуба

/////////////////////////////////////////////////////////если после старта температура работы на себя больше настройки, то начинаем работу на себя
  if (rej==3&is_start>0&rej_step==0&tow_temp>par[0])
  {
    rej_step=1;
  }

/////////////////////////////////////////////////////////если мы в отборе голов, опускаем иглу на уровень тела, чтобы наполнить иглу
  if (rej==3&is_start>0&rej_step==2&is_down==0)
  {
    fact2_rev_count=0;                  
    rev2_count = head_r_count;
    
    rev_count = body_count;
    rev_curr=rev_curr+rev_count;
    is_down=1;
  }

////////////////////////////////////////////////////////как тольо игла спущена, запускаем таймер отсчета
  if (rej==3&is_start>0&rej_step==2&is_down==1&rev_count==fact_rev_count)
  {
    down_count=par[6]*60;
    is_down=2;
  }

///////////////////////////////////////////////////////как только время заполнения иглы прошло, поднимаем иглу на уровень голов
  if (rej==3&is_start>0&rej_step==2&is_down==3&rev_count==fact_rev_count&rev_count!=0)
  {
    fact_rev_count=0;
    rev_count = -(body_count-head_count);
    rev_curr=rev_curr+rev_count;
    is_down=4;
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////ТЕЛО
  ////////////////////////////////////////////////////начинаем отбор тела с нижней позиции

////////обработка стопа
    if (rej>2&is_start>0&rej_step==4&tow_temp-stab_temp>4&flstop==0)
    {
       fstop++;        
       flstop=1;
       tic_voice=100;
       tic_tal=par[10]*600;
    }

  if (rej>2&is_start>0&rej_step==4&flstop>0&rev_count==fact_rev_count)
  {
    fact_rev_count=0;
    rev_count=-rev_curr;
    rev_curr=rev_curr+rev_count;
  }

  if (rej>2&is_start>0&rej_step==4&flstop>0&tow_temp-stab_temp<3&stab_temp>0&rev_count==fact_rev_count&tic_tal>0)
  {
    tic_tal=0;
    flstop=0;
    stab_temp=tow_temp;
    fact_rev_count=0;
    rev_count = stopcurr;
    rev_curr=rev_curr+rev_count;
  }



////////обработка стопа





  
  //вычислим количество шагов снижения отбора
  kstep=par[2]-par[1];
  //вычислим процент снижения при текущей температуре
  currstep=((curr_temp-par[1])*100/kstep)+fstop*10;
  //вычислим шаги на подъем
  delstep=(body_count)-((body_count-head_count)*currstep/100);
  
  
  if (rej>2&is_start>0&rej_step==4&curr_temp<=par[2]&curr_temp>=par[1]&rev_count==fact_rev_count&rev_curr>delstep&flstop==0)
  {
    fact_rev_count=0;
    rev_count= - (rev_curr-delstep );
    rev_curr=rev_curr+rev_count;
    stopcurr=rev_curr;
  }
  

//////////////////////////////////////////////////////////////////////////////////////////////////////////////ТЕЛО



////////////////////////////////////////////////////////Если температура больше, чем температура отбора тела, то поднимаем иглу
////////////////////////////////////////////////////////и ждем смены тары
  if (rej>2&is_start>0&rej_step==4&((curr_temp>par[3])|(tow_temp-stab_temp>2&stab_temp>0&tic_tal==0&flstop>0)/*|(rev_curr<=kol_head&rev_count==fact_rev_count)*/))
  {
    flstop=0;
 
 if (par[11]==0)
{
      rej_step=5;
     fact_rev_count=0;
    rev_count=-rev_curr;
    rev_curr=rev_curr+rev_count;

}
else
{
  tic_voice=10;
    fact2_rev_count=0;                  
    rev2_count = tal_r_count-body_r_count;

              fact_rev_count=0;
              rev_count=body_count-rev_curr;
              rev_curr=rev_curr+rev_count;
              rej_step=6;
}
   
  }


  if (rej>2&is_start>0&rej_step==6&curr_temp>par[4]&rev_count==fact_rev_count)
  {
    rej_step=7;    

    fact_rev_count=0;
    rev_count=-body_count;
    rev_curr=rev_curr+rev_count;
  }



  if (rej>2)
  {
    if(is_start>0&(rej_step==3|rej_step==5))
    {
    if (voicetype==1)
    {
      digitalWrite(Pin_voice,LOW);
    }
    else
    {
      digitalWrite(Pin_voice,HIGH);
    }
    }
    else
    {
    if (voicetype==1)
    {
      digitalWrite(Pin_voice,HIGH);
    }
    else
    {
      digitalWrite(Pin_voice,LOW);
    }
    }

  }
  if(rej>2&is_start>0&rej_step==7)
  {
    digitalWrite(Pin_relay,HIGH);
  }
  else
  {
    digitalWrite(Pin_relay,LOW);
  }



  //////////////////////////////////END/////////////////алгоритм 1 - ректификация по Ткуба

  set_display();
}





